program test;
uses Crt;
var ba,CisloParu,b:integer;
    cekani:longint;
    DCD,DSR,CTS,RI:byte; {stav vstupu (0 nebo 1)}
    ch:char;

procedure tkurzorvyp; assembler; {vypnuti kurzoru}
Asm
mov AH,1
mov CX,$1000
int $10
End;

procedure tkurzorzap; assembler; {zapnuti kurzoru}
Asm
mov AH,1
mov CX,$0607
int $10
End;

procedure stop; {vypne vsechny vystupy}
Begin
port[ba+4]:=0; {DTR a RTS}
port[ba+3]:=0; {TXD}
End;

procedure start; {zapne vystup TXD (napajeni IO)}
Begin
port[ba+3]:=64;
End;

procedure reset; {na chvilku zapne vystup DTR (reset IO)}
Begin
port[ba+4]:=1;
delay(10);
port[ba+4]:=0;
End;

procedure VyberPort; {necha uzivatele zadat cislo portu, na kterem je pripojeny tester}
Begin
gotoxy(24,2);
write('<<C>2006 VAGNER > TEST UTP KABELU');
gotoxy(26,4);
write('!!VYBER PORT PRO PRIPRAVEK!!');
gotoxy(19,6);
write('!!<1>COM1 , <2>COM2 , <3>COM3 , <4>COM4 !!');
gotoxy(15,10);
writeln('Volbu portu provedeme stiskem klavesy v zavorce < >.');
case readkey of '1':ba:=$3F8;
                '2':ba:=$2F8;
                '3':ba:=$3E8;
                '4':ba:=$2E8;
                end;
End;

procedure rucne;
Begin
clrscr;
reset;
gotoxy(20,4);
write('! <V> - ZPET NA VYBER RUCNE/AUTOMAT !');
gotoxy(16,6);
write('! <MEZERNIK> - VYBER JINEHO VYSTUPNIHO PARU !');
 repeat
 gotoxy(20,8); clreol;
 write('! ZADEJ CISLO VYSTUPNIHO PARU 1..4 ! ');
 tkurzorzap;
 read(cisloparu);
 tkurzorvyp;
 for b:=1 to cisloparu do begin
                          {puls na vystupu RTS (prepinaci takt pro IO):}
                          port[ba+4]:=2;
                          delay(10);
                          port[ba+4]:=0;
                          delay(10);
                          end;
 cts:=(port[ba+6] shr 4) and 1;
 dsr:=(port[ba+6] shr 5) and 1;
 ri :=(port[ba+6] shr 6) and 1;
 dcd:=(port[ba+6] shr 7) and 1;
 gotoxy(27,10);
 write('! ZAPNUT VYSTUPNI PAR ',cisloparu,' !');
 gotoxy(31,12);
 write('PRVNI PAR JE   ',cts);
 gotoxy(31,14);
 write('DRUHY PAR JE   ',dsr);
 gotoxy(31,16);
 write('TRETI PAR JE   ',ri);
 gotoxy(31,18);
 write('CTVRTY PAR JE  ',dcd);
 repeat until keypressed;
 reset;
 gotoxy(20,10); clreol;
 gotoxy(25,12); clreol;
 gotoxy(25,14); clreol;
 gotoxy(25,16); clreol;
 gotoxy(25,18); clreol;
 ch:=upcase(readkey);
 until ch in ['V',chr(27)];
End;

procedure automat;
Begin
clrscr;
gotoxy(21,4);
write('! <V> - ZPET NA VYBER RUCNE/AUTOMAT !');
gotoxy(17,6);
write('! <MEZERNIK> - ZADANI JINEHO CASU PREPINANI !');
 repeat
 {zadani casu prepinani:}
 gotoxy(21,8); clreol;
 write('! ZADEJ CAS PREPINANI VE VTERINACH ! ');
 tkurzorzap;
 read(cekani);
 tkurzorvyp;
 cekani:=1000*cekani; {prevod sekund na milisekundy}
 reset;
 cisloparu:=0; {po resetu zaciname na vystupu Q0, na prvni par se teprve dostaneme}
 {pracovni cyklus pro prepinani paru:}
  repeat
  {prepnuti na dalsi par (napoprve se prepne na prvni):}
  port[ba+4]:=2;
  delay(10);
  port[ba+4]:=0;
  delay(10);
  inc(cisloparu);
  {nacteni vstupu:}
  cts:=(port[ba+6] shr 4) and 1;
  dsr:=(port[ba+6] shr 5) and 1;
  ri :=(port[ba+6] shr 6) and 1;
  dcd:=(port[ba+6] shr 7) and 1;
  {zobrazeni vysledku:}
  gotoxy(28,10);
  writeln('! ZAPNUT VYSTUPNI PAR  ',cisloparu,' !');
  gotoxy(32,12);
  write('PRVNI PAR JE   ',cts);
  gotoxy(32,14);
  write('DRUHY PAR JE   ',dsr);
  gotoxy(32,16);
  write('TRETI PAR JE   ',ri);
  gotoxy(32,18);
  write('CTVRTY PAR JE  ',dcd);
  {pockame zadanou dobu, abychom si vysledky stihli precist:}
  delay(cekani);
  {jestli uz jsme u posledniho, skocime zpatky na zacatek:}
  if cisloparu=4 then begin
                      reset;
                      cisloparu:=0;
                      end;
  until keypressed; {prepiname porad dokola az do stisku klavesy}
 gotoxy(20,10); clreol;
 gotoxy(25,12); clreol;
 gotoxy(25,14); clreol;
 gotoxy(25,16); clreol;
 gotoxy(25,18); clreol;
 ch:=upcase(readkey);
 until ch in ['V',chr(27)]; {V a Esc konci, ostatni klavesy vraceji zpatky na zadani casu}
reset;
End;

procedure vyber;
Begin
clrscr;
gotoxy(8,2);
write('! VYBER TEST  <R>UCNE nebo <A>UTOMAT  ;  <ESC> KONEC PROGRAMU !');
ch:=upcase(readkey);
case ch of 'R':rucne;
           'A':automat;
           end;
End;

BEGIN
tkurzorvyp;
textbackground(white);
textcolor(black);
clrscr;
vyberport;
stop;
delay(100);
start;
 repeat
 vyber;
 until ch=chr(27);
stop;
tkurzorzap;
normvideo;
clrscr;
END.